import java.io.*;
import java.util.*;

public class Main {
	public static void main(String[] args) {
		InputStream inputStream = System.in;
		OutputStream outputStream = System.out;
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		Task solver = new Task();
		solver.solve(1, in, out);
		out.close();
	}

	static class Task {
        
		public void solve(int testNumber, InputReader in, PrintWriter out) {
			long n = in.nextLong();
			int q = in.nextInt();
		    
		    for (int i = 0; i < q; ++i) {
		        long x = in.nextLong();
		        out.println(get(n, x));
		    }
		}
		
		public long get(long n, long x) {
		    if (x % 2 == 1) {
                return (x >> 1) + 1;
            }
            
            long num_right = n - (x >> 1) - 1;
            return get(n, x + num_right + 1);
		}
	}

	static class InputReader {
		public BufferedReader reader;
		public StringTokenizer tokenizer;

		public InputReader(InputStream stream) {
			reader = new BufferedReader(new InputStreamReader(stream), 32768);
			tokenizer = null;
		}

		public String next() {
			while (tokenizer == null || !tokenizer.hasMoreTokens()) {
				try {
					tokenizer = new StringTokenizer(reader.readLine());
				} catch (IOException e) {
					throw new RuntimeException(e);
				}
			}
			return tokenizer.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(next());
		}
		
		public long nextLong() {
			return Long.parseLong(next());
		}
	}
}
